import numpy, cv2

cap = cv2.VideoCapture(0)
cv2.ocl.setUseOpenCL(False)
#cap.set(cv2.cv.CV_CAP_PROP_FRAME_WIDTH, 640)
#cap.set(cv2.cv.CV_CAP_PROP_FRAME_HEIGHT, 480)

max_pts = 500
# SURF with the Hessian parameter
#sift = cv2.SURF(300)
sift = cv2.ORB_create(max_pts)

bf = cv2.BFMatcher(crossCheck=True) # Bruteforce matcher
desc0 = None # To store descriptors
color = numpy.random.randint(0,255,(max_pts,3)) # Random color for kp

while 1:
    stat, image = cap.read(0)
    image = cv2.resize(image, (image.shape[1]/2, image.shape[0]/2))
    disp = image.copy()

    # Find keypoints and their descriptors
    kp, desc = sift.detectAndCompute(image, None)
    cv2.drawKeypoints(image, kp, disp, color=(0,255,0))

    if desc0 != None:
        # Match the saved and the latest kp's
        matches = bf.match(desc0, desc)
        src_pts = numpy.float32([ kp0[m.queryIdx].pt \
                                  for m in matches ]).reshape(-1,1,2)
        dst_pts = numpy.float32([ kp[m.trainIdx].pt \
                                  for m in matches ]).reshape(-1,1,2)
        F, mask = cv2.findFundamentalMat(src_pts, dst_pts, cv2.FM_RANSAC)
        src_pts0 = src_pts[mask == 1]
        dst_pts0 = dst_pts[mask == 1]

        for i in range(min(max_pts,len(matches))):
            # Matched pair: kp0[m.queryIdx] <--> kp[m.trainIdx]
            m = matches[i]
            if mask[i] == 0:
                continue;
            (a, b) = kp[m.trainIdx].pt
            (c, d) = kp0[m.queryIdx].pt
            cv2.circle(disp, (int(a), int(b)), 5,\
                       color[m.queryIdx%max_pts].tolist(), -1)
            cv2.line(disp, (int(a), int(b)), (int(c), int(d)),\
                     color[m.queryIdx%max_pts].tolist(), 2)

    cv2.imshow('Camera', disp)
    key = cv2.waitKey(10)

    if key == 0x1b: # ESC
        cv2.imwrite('img1.png', image)
        numpy.savetxt('fundM.txt', F)
        numpy.savetxt('pts0.txt', src_pts0)
        numpy.savetxt('pts1.txt', dst_pts0)
        break
    elif key == 0x20:
        desc0 = desc.copy()
        kp0 = kp[:]
        cv2.imwrite('img0.png', image)
        print 'Target updated!'
